﻿using SilverlightApplication1;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Windows.Controls;

namespace SilverlightApplication1
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();
			this.DataContext = new ViewModel();
		}
	}

	public class ViewModel : INotifyPropertyChanged
	{
		private DataItem selectedDataItem;

		public ViewModel()
		{
			this.DataItems = new ObservableCollection<DataItem>();
			for (int i = 0; i < 5; i++)
			{
				DataItem d1 = new DataItem();
				d1.Header = string.Format("Item {0}", i);
				for (int j = 0; j < 5; j++)
				{
					DataItem d2 = new DataItem();
					d2.Header = string.Format("Item {0}.{1}", i,j);
					d1.Children.Add(d2);
				}
				this.DataItems.Add(d1);
			}
			this.SelectedDataItem = this.DataItems[0];
		}

		public ObservableCollection<DataItem> DataItems
		{
			get;
			private set;
		}

		public DataItem SelectedDataItem
		{
			get
			{
				return this.selectedDataItem;
			}
			set
			{
				if (this.selectedDataItem != value)
				{
					this.selectedDataItem = value;
					this.OnPropertyChanged("SelectedDataItem");
				}
			}
		}

		public event PropertyChangedEventHandler PropertyChanged;

		private void OnPropertyChanged(string propertyName)
		{
			if (this.PropertyChanged != null)
			{
				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}

	}

	public class DataItem
	{
		public DataItem()
		{
			this.Children = new ObservableCollection<DataItem>();
		}

		public string Header
		{
			get;
			set;
		}
		
		public ObservableCollection<DataItem> Children
		{
			get;
			private set;
		}
	}
}
